# Hello worlding

In this presentation i will look at the work made across the 2 years to reflect on how it changed my understanding of programming and code documentation.

Code documentation here is intended as a broad set of practices: comments in code, readme files, tutorials, guides, references etc., but also moments of collective learning, workshops, pair programming and collaborative versioning.

These aspects are usually marginal in software development: byproducts surrounding the real thing, extra work, and demand of resources often not available in the scarce economy around documentation.

I would like to focus on these marginal zones, bring them to the center and reflect on how do they enrich practices of programming, opening entry points and backdoors into the making of software for people that are usually left out.

The institutional required list of things done during these two years is left in the background, squint your eyes and move the cursor to the edges to see through. 

## Getting startled

- coming to xpub with some previous experience in software development
- a practice mainly used to develop interactive tools
- visual art, performance and dance
- but also corporate web design / development

<br>

- coding embedding different values
- coding as craftmanship, coding as service, coding to understand our surroundings
- code as solution, coding as profession, code as product

<br>

- enroll in XPUB, meet the group
- different backgrounds different skills different values
- different ways of working together
- 1 important thing in common
- (soup)

<br>

__how to program together with different programming knowledge__

<br>

- first months: 
- incredible
- new things: self-hosting, soupboat as shared space, the terminal, python
- sharing knowledges (see workshops)
- the terror of modifying files in the soupboat and break everything
- only timid and minimal modification in the homepage
- lot of different prototypes with my classmates!
- cute to look back and see the level where we started 
- (see tech questions in soup-gen, cringe & funny & empowering)

<br>

- some prototypes found their way through the two years :) 
- (see text weaving, from si16 to the screenless office workshop to jian final project)
- some others no! but have been documented! so wont be forgotten
- first things to take home: started documenting things
- the famous documentation workout that was one of the objective to achieve in these two years :) 

<br>

- but also traumatic!
- suffered moments of severe stress after first two SIs
- friction and contrast between:
- care within the group, attention to group dynamics
- group expectations and ambitions for projects
- deadlines and production plans

<br>

- ended up centralizing a lot of technical work
- always available and excited to share / offer skills to make things happen 
- but not always taking into consideration the overall group engagement with programming

<br>

__realized after many year of collective practice that there's a difference in making something for a group and making something together.__


<br>

- the parable of SI18 was healing
- and as healing works, it hurt a bit on the way
- smaller groups, rotation between caretakers and contributors, pace uptempo
- sometimes was difficult to give value to things made in such a rush
- but on the course of the weekly releases something changed
- at the beginning we were just giving themes or keywords as prompts
- later on it transformed to offering formats and inviting particular workflows

<br>

## From code to code documentation

- these ideas of __invitation, offering, proposal__ resonated a lot
- especially with the concept of _situated software_
- aka software made with and within a group, on a shared infra- and social- structure
- coding as care

<br>

- at first wondered if the moment of offering and proposal could have been the format of the __demo__
- _mother of all demos_ vibe
- but as an approach felt too frontal and binary
- developer vs user
- and i didn't feel really connected with _demoscene_

Eventually i focused on something closer to home: __the friction between being frustrated having to deal with undocumented piece of software, and at the same time never documenting anything.__

And realized that what I'm interested on besides developing tools, is the moment of development itself. And a way to share that moment and its surroundings with others it's code documentation. 

> Code documentation is an interface between the code, the user, the developer, and the world. Living close to the source code, but at the same time being less rigid and more expressive, it seems to be an ideal surface to influence software development practices.

And that was more or less the moment when I started being more aware about my and others approach to documentation.

- Putting more efforts in writing readmes
- Hosting workshops to share code
- Organizing documentation sessions to dedicate time to writing docs
- Making zine with prompts to start documenting, [care for code](https://hub.xpub.nl/soupboat/~kamo/care_for_code/) 

![scanned materials for the documentation sessions. some sticker, flyers and text, printed on pink paper](https://hub.xpub.nl/soupboat/~kamo/projects/dyc/gadget.jpg)  
_Materials printed for documentation session_

![Scan of the zine Care for Code](https://hub.xpub.nl/soupboat/~kamo/static/img/care_for_code.png)  
_Care for code - zine for Documentation Session_


And learned how diverse and rich practices of code documentation can be: 

__Code documentation as personal understanding__

![a drawing with a cute bird playing the role of an API between server and client](https://hub.xpub.nl/soupboat/wlist/img/chae_api.jpg)

![a screenshot of a meme with a soaked sweated man trying not to use the analogy of the restaurant to explain the api](https://hub.xpub.nl/soupboat/~kamo/static/img/miri.jpg)

![fancy graphic designed documentation to digest flask](https://hub.xpub.nl/soupboat/wlist/img/supi_flask.jpg)

_Chae's drawing - Miri's meme - Supi's diyry_

<br>

__Code documentation as shared struggle__

![comment in code: ](https://hub.xpub.nl/soupboat/~kamo/static/img/comment_1.png)  
![comment in code](https://hub.xpub.nl/soupboat/~kamo/static/img/comment_2.png)  
![comment in code](https://hub.xpub.nl/soupboat/~kamo/static/img/comment_3.png)  
![comment in code](https://hub.xpub.nl/soupboat/~kamo/static/img/comment_4.png)  
![comment in code](https://hub.xpub.nl/soupboat/~kamo/static/img/comment_5.png)

_Comments in the code screaming for help_

<br>

__Code documentation as collective practice__

![Documentation for a repeat function with some nice parrot](https://hub.xpub.nl/soupboat/~kamo/thesis/img/SI16_NB.jpg)
_Folder with Jupiter notebook files, each with a different piece of documentation for SI16_


![piece of flask documentation written with Chae](https://hub.xpub.nl/soupboat/~kamo/static/img/flask.png)  
_Writing some documentation for Flask together with Chae_

- Code documentation as facilitation to distributed authorship
- Code documentation as poetic and political writing
- Code documentation as invitation for others to participate
- Code documentation as starting point for further explorations 
- Code documentation as a way to question code




## plans for final publication and grad show

code documentation is a marginal practice, often invisible labor, usually left in the background. for grad show and final pubblication would like to bring it more to the center.

There will be 2 kind of things at the exhibition

### 1. helloworlding.com 

Is a small website to archive a pathways through code documentation practice.
at the current stage a pathway is an annotated collection of readmes. Readmes are presented with a short intro and link directly at the place where they originally can be found, that is in their repos. 

It will be exhibited on a small screen connected to the Soupboat, for the occasion going on a field trip at the slash gallery.

This archive is a <span class="double"><span>reading</span><span>writing</span></span> machine.

- __reading__ because it's a curated restitution of different practices of code docs
- __writing__ because it systematizes a research process, offering a surface where to keep track of methods through time, and see through snapshots how they transform over time

Pathways available at the moment:

1. welcoming language as a mode of address
2. cover arts and visual entry points

_The website will work as an invitation, with the possibility to sign in to receive update about new pathways, and activation._    

### 2. readme readers

Keyword are:
__readme republishing__
__readme readers__

There will be printed snapshots of readme files mainly coming from tools developed in the context of the soupboat, bound together as _readme readers_ by means of a custom, loose binding setup.

These readers will be a snapshot of the current pathways curated in [helloworlding.com](helloworlding.com)  

To bring under spotlight a theme that is __a niche in a niche__ requires to create some entry points to be relatable. Code documentation is a surface in the middle of different kinds of audience, so different kind of entry points are necessary.
These are aspects of code documentation practices I want to be reflected in the installation setup: 

- __proximity to the code__: as a lens to look at it, as an entry point to let people in. as a bait to lure a tech audience not so used to this kind of discourses about sociality around software. 

- __multiplicity__: many different situations, many different ways to document, not 1 size fits all

- __worlding__: documentation can influence the way we think about code. can create worlds around it. system of values different from ultra optimization, productivity and tech solutionism 

that's why for the exhibition im binding the readme readers with __clumsy 3d printed legs__. These legs started as a playful device to make our server run 4x faster, and eventually became one of visible marks of software developed around Soupboat

As binding device they work as:

- a small pack of goofy creatures in the ecosystem of soupboat
- a playful display for a usually intimidating material 
- embracing clumsyness, unfinished and provisional states, tryout and failures, commitment to constant gardening and care for code documentation, its readers and all the surroundings 


picture picture
picture picture






























































that's why i decided

by legs system
- to make them wander aroudn the exhibition space 




